/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 9 "../bpf_parser.y"


#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <signal.h>
#include <stdint.h>
#include <errno.h>

#include "bpf.h"
#include "xmalloc.h"
#include "bpf_parser.tab.h"
#include "built_in.h"
#include "die.h"

#define MAX_INSTRUCTIONS	4096

int compile_filter(char *file, int verbose);

static int curr_instr = 0;

static struct sock_filter out[MAX_INSTRUCTIONS];

static char *labels[MAX_INSTRUCTIONS];

static char *labels_jt[MAX_INSTRUCTIONS];
static char *labels_jf[MAX_INSTRUCTIONS];
static char *labels_k[MAX_INSTRUCTIONS];

#define YYERROR_VERBOSE		0
#define YYDEBUG			0
#define YYENABLE_NLS		1
#define YYLTYPE_IS_TRIVIAL	1
#define ENABLE_NLS		1

extern FILE *yyin;
extern int yylex(void);
extern void yyerror(const char *);
extern int yylineno;
extern char *yytext;

static inline void set_curr_instr(uint16_t code, uint8_t jt, uint8_t jf, uint32_t k)
{
	if (curr_instr >= MAX_INSTRUCTIONS)
		panic("Exceeded maximal number of instructions!\n");

	out[curr_instr].code = code;
	out[curr_instr].jt = jt;
	out[curr_instr].jf = jf;
	out[curr_instr].k = k;

	curr_instr++;
}

static inline void set_curr_label(char *label)
{
	if (curr_instr >= MAX_INSTRUCTIONS)
		panic("Exceeded maximal number of instructions!\n");

	labels[curr_instr] = label;
}

#define JTL 1
#define JFL 2
#define JKL 3

static inline void set_jmp_label(char *label, int which)
{
	if (curr_instr >= MAX_INSTRUCTIONS)
		panic("Exceeded maximal number of instructions!\n");

	bug_on(which != JTL && which != JFL && which != JKL);

	if (which == JTL)
		labels_jt[curr_instr] = label;
	else if (which == JFL)
		labels_jf[curr_instr] = label;
	else
		labels_k[curr_instr] = label;
}

static int find_intr_offset_or_panic(char *label_to_search)
{
	int i, max = curr_instr, ret = -ENOENT;

	bug_on(!label_to_search);

	for (i = 0; i < max; ++i) {
		if (labels[i] != NULL) {
			/* Both are \0-terminated! */
			if (!strcmp(label_to_search, labels[i])) {
				ret = i;
				break;
			}
		}
	}

	if (ret == -ENOENT)
		panic("No such label!\n");

	return ret;
}


/* Line 371 of yacc.c  */
#line 173 "/builddir/build/BUILD/netsniff-ng-0.5.7/src/build/bpfc/bpf_parser.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "bpf_parser.tab.h".  */
#ifndef YY_YY_BUILDDIR_BUILD_BUILD_NETSNIFF_NG_0_5_7_SRC_BUILD_BPFC_BPF_PARSER_TAB_H_INCLUDED
# define YY_YY_BUILDDIR_BUILD_BUILD_NETSNIFF_NG_0_5_7_SRC_BUILD_BPFC_BPF_PARSER_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     OP_LDB = 258,
     OP_LDH = 259,
     OP_LD = 260,
     OP_LDX = 261,
     OP_ST = 262,
     OP_STX = 263,
     OP_JMP = 264,
     OP_JEQ = 265,
     OP_JGT = 266,
     OP_JGE = 267,
     OP_JSET = 268,
     OP_ADD = 269,
     OP_SUB = 270,
     OP_MUL = 271,
     OP_DIV = 272,
     OP_AND = 273,
     OP_OR = 274,
     OP_LSH = 275,
     OP_RSH = 276,
     OP_RET = 277,
     OP_TAX = 278,
     OP_TXA = 279,
     OP_LDXB = 280,
     K_PKT_LEN = 281,
     K_PROTO = 282,
     K_TYPE = 283,
     K_IFIDX = 284,
     K_NLATTR = 285,
     K_NLATTR_NEST = 286,
     K_MARK = 287,
     K_QUEUE = 288,
     K_HATYPE = 289,
     K_RXHASH = 290,
     K_CPU = 291,
     K_COMMENT = 292,
     number_hex = 293,
     number_dec = 294,
     label = 295,
     comment = 296
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 114 "../bpf_parser.y"

	char *label;
	long int number;


/* Line 387 of yacc.c  */
#line 263 "/builddir/build/BUILD/netsniff-ng-0.5.7/src/build/bpfc/bpf_parser.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE yylval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_YY_BUILDDIR_BUILD_BUILD_NETSNIFF_NG_0_5_7_SRC_BUILD_BPFC_BPF_PARSER_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 291 "/builddir/build/BUILD/netsniff-ng-0.5.7/src/build/bpfc/bpf_parser.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   229

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  55
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  30
/* YYNRULES -- Number of rules.  */
#define YYNRULES  107
/* YYNRULES -- Number of states.  */
#define YYNSTATES  223

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   296

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,    50,     2,     2,    49,     2,
      42,    43,    48,    46,    39,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    38,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    47,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    40,     2,    41,     2,     2,     2,    45,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      44,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    51,    52,    53,    54
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     7,     9,    11,    14,    16,    18,
      20,    22,    24,    26,    28,    30,    32,    34,    36,    38,
      40,    42,    44,    46,    48,    50,    52,    54,    56,    58,
      60,    62,    64,    66,    69,    76,    81,    85,    89,    93,
      97,   101,   105,   109,   113,   117,   121,   128,   133,   137,
     141,   145,   149,   153,   157,   161,   165,   169,   173,   177,
     181,   185,   189,   193,   197,   201,   205,   209,   213,   217,
     221,   227,   234,   239,   243,   249,   260,   271,   277,   283,
     286,   294,   301,   309,   316,   324,   331,   339,   346,   350,
     353,   357,   360,   364,   367,   371,   374,   378,   381,   385,
     388,   392,   395,   399,   402,   405,   409,   411
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      56,     0,    -1,    -1,    56,    57,    -1,    59,    -1,    58,
      -1,    62,    59,    -1,    63,    -1,    64,    -1,    65,    -1,
      66,    -1,    67,    -1,    68,    -1,    69,    -1,    70,    -1,
      71,    -1,    72,    -1,    73,    -1,    74,    -1,    75,    -1,
      76,    -1,    77,    -1,    78,    -1,    79,    -1,    80,    -1,
      81,    -1,    82,    -1,    83,    -1,    84,    -1,    61,    -1,
      52,    -1,    51,    -1,    37,    -1,    53,    38,    -1,     3,
      40,    44,    46,    60,    41,    -1,     3,    40,    60,    41,
      -1,     3,    50,    27,    -1,     3,    50,    28,    -1,     3,
      50,    29,    -1,     3,    50,    30,    -1,     3,    50,    31,
      -1,     3,    50,    32,    -1,     3,    50,    33,    -1,     3,
      50,    34,    -1,     3,    50,    35,    -1,     3,    50,    36,
      -1,     4,    40,    44,    46,    60,    41,    -1,     4,    40,
      60,    41,    -1,     4,    50,    27,    -1,     4,    50,    28,
      -1,     4,    50,    29,    -1,     4,    50,    30,    -1,     4,
      50,    31,    -1,     4,    50,    32,    -1,     4,    50,    33,
      -1,     4,    50,    34,    -1,     4,    50,    35,    -1,     4,
      50,    36,    -1,     5,    50,    60,    -1,     5,    50,    26,
      -1,     5,    50,    27,    -1,     5,    50,    28,    -1,     5,
      50,    29,    -1,     5,    50,    30,    -1,     5,    50,    31,
      -1,     5,    50,    32,    -1,     5,    50,    33,    -1,     5,
      50,    34,    -1,     5,    50,    35,    -1,     5,    50,    36,
      -1,     5,    47,    40,    60,    41,    -1,     5,    40,    44,
      46,    60,    41,    -1,     5,    40,    60,    41,    -1,     6,
      50,    60,    -1,     6,    47,    40,    60,    41,    -1,    25,
      60,    48,    42,    40,    60,    41,    49,    60,    43,    -1,
       6,    60,    48,    42,    40,    60,    41,    49,    60,    43,
      -1,     7,    47,    40,    60,    41,    -1,     8,    47,    40,
      60,    41,    -1,     9,    53,    -1,    10,    50,    60,    39,
      53,    39,    53,    -1,    10,    44,    39,    53,    39,    53,
      -1,    11,    50,    60,    39,    53,    39,    53,    -1,    11,
      44,    39,    53,    39,    53,    -1,    12,    50,    60,    39,
      53,    39,    53,    -1,    12,    44,    39,    53,    39,    53,
      -1,    13,    50,    60,    39,    53,    39,    53,    -1,    13,
      44,    39,    53,    39,    53,    -1,    14,    50,    60,    -1,
      14,    44,    -1,    15,    50,    60,    -1,    15,    44,    -1,
      16,    50,    60,    -1,    16,    44,    -1,    17,    50,    60,
      -1,    17,    44,    -1,    18,    50,    60,    -1,    18,    44,
      -1,    19,    50,    60,    -1,    19,    44,    -1,    20,    50,
      60,    -1,    20,    44,    -1,    21,    50,    60,    -1,    21,
      44,    -1,    22,    45,    -1,    22,    50,    60,    -1,    23,
      -1,    24,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   134,   134,   135,   139,   140,   144,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     174,   175,   179,   183,   187,   189,   191,   194,   197,   200,
     203,   206,   209,   212,   215,   218,   224,   226,   228,   231,
     234,   237,   240,   243,   246,   249,   252,   255,   261,   263,
     265,   268,   271,   274,   277,   280,   283,   286,   289,   292,
     295,   297,   299,   304,   306,   308,   313,   321,   326,   331,
     337,   341,   348,   352,   359,   363,   370,   374,   381,   383,
     388,   390,   395,   397,   402,   404,   409,   411,   416,   418,
     423,   425,   430,   432,   437,   439,   444,   449
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "OP_LDB", "OP_LDH", "OP_LD", "OP_LDX",
  "OP_ST", "OP_STX", "OP_JMP", "OP_JEQ", "OP_JGT", "OP_JGE", "OP_JSET",
  "OP_ADD", "OP_SUB", "OP_MUL", "OP_DIV", "OP_AND", "OP_OR", "OP_LSH",
  "OP_RSH", "OP_RET", "OP_TAX", "OP_TXA", "OP_LDXB", "K_PKT_LEN",
  "K_PROTO", "K_TYPE", "K_IFIDX", "K_NLATTR", "K_NLATTR_NEST", "K_MARK",
  "K_QUEUE", "K_HATYPE", "K_RXHASH", "K_CPU", "K_COMMENT", "':'", "','",
  "'['", "']'", "'('", "')'", "'x'", "'a'", "'+'", "'M'", "'*'", "'&'",
  "'#'", "number_hex", "number_dec", "label", "comment", "$accept", "prog",
  "line", "labeled_instr", "instr", "number", "do_comment", "do_label",
  "do_ldb", "do_ldh", "do_ld", "do_ldx", "do_st", "do_stx", "do_jmp",
  "do_jeq", "do_jgt", "do_jge", "do_jset", "do_add", "do_sub", "do_mul",
  "do_div", "do_and", "do_or", "do_lsh", "do_rsh", "do_ret", "do_tax",
  "do_txa", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    58,    44,
      91,    93,    40,    41,   120,    97,    43,    77,    42,    38,
      35,   293,   294,   295,   296
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    55,    56,    56,    57,    57,    58,    59,    59,    59,
      59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
      60,    60,    61,    62,    63,    63,    63,    63,    63,    63,
      63,    63,    63,    63,    63,    63,    64,    64,    64,    64,
      64,    64,    64,    64,    64,    64,    64,    64,    65,    65,
      65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
      65,    65,    65,    66,    66,    66,    66,    67,    68,    69,
      70,    70,    71,    71,    72,    72,    73,    73,    74,    74,
      75,    75,    76,    76,    77,    77,    78,    78,    79,    79,
      80,    80,    81,    81,    82,    82,    83,    84
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     6,     4,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     6,     4,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       5,     6,     4,     3,     5,    10,    10,     5,     5,     2,
       7,     6,     7,     6,     7,     6,     7,     6,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     2,     3,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     1,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   106,   107,     0,    32,     0,     3,     5,
       4,    29,     0,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    31,    30,     0,     0,     0,    79,
       0,     0,     0,     0,     0,     0,     0,     0,    89,     0,
      91,     0,    93,     0,    95,     0,    97,     0,    99,     0,
     101,     0,   103,     0,   104,     0,     0,    33,     6,     0,
       0,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,     0,     0,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,     0,     0,     0,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    58,     0,    73,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    88,    90,    92,    94,    96,    98,   100,   102,   105,
       0,     0,    35,     0,    47,     0,    72,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    70,    74,     0,    77,    78,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    34,    46,
      71,     0,    81,     0,    83,     0,    85,     0,    87,     0,
       0,     0,    80,    82,    84,    86,     0,     0,     0,     0,
       0,    76,    75
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,    28,    29,    30,    66,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -49
static const yytype_int16 yypact[] =
{
     -49,     2,   -49,    -9,    -5,    -7,   108,   -46,   -19,   -24,
       3,     7,    15,    17,    19,    64,    65,    85,    87,    89,
     129,   130,    -8,   -49,   -49,   -48,   -49,     6,   -49,   -49,
     -49,   -49,    68,   -49,   -49,   -49,   -49,   -49,   -49,   -49,
     -49,   -49,   -49,   -49,   -49,   -49,   -49,   -49,   -49,   -49,
     -49,   -49,   -49,   -49,   -49,    50,   118,    52,   135,    55,
       9,    92,    57,   -48,   -49,   -49,    47,    58,    70,   -49,
      72,   -48,    73,   -48,    91,   -48,    93,   -48,   -49,   -48,
     -49,   -48,   -49,   -48,   -49,   -48,   -49,   -48,   -49,   -48,
     -49,   -48,   -49,   -48,   -49,   -48,    86,   -49,   -49,    95,
     101,   -49,   -49,   -49,   -49,   -49,   -49,   -49,   -49,   -49,
     -49,   110,   116,   -49,   -49,   -49,   -49,   -49,   -49,   -49,
     -49,   -49,   -49,   131,   134,   -48,   -49,   -49,   -49,   -49,
     -49,   -49,   -49,   -49,   -49,   -49,   -49,   -49,   -48,   -49,
     136,   -48,   -48,   123,   142,   132,   143,   133,   144,   137,
     145,   -49,   -49,   -49,   -49,   -49,   -49,   -49,   -49,   -49,
     146,   -48,   -49,   -48,   -49,   -48,   -49,   148,   150,   147,
     153,   154,   157,   149,   158,   151,   159,   152,   160,   155,
     161,   162,   165,   166,   -49,   -49,   -48,   -49,   -49,   156,
     171,   163,   172,   164,   173,   167,   174,   -48,   -49,   -49,
     -49,   177,   -49,   168,   -49,   169,   -49,   170,   -49,   175,
     178,   176,   -49,   -49,   -49,   -49,   180,   -48,   -48,   181,
     183,   -49,   -49
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -49,   -49,   -49,   -49,   182,   -25,   -49,   -49,   -49,   -49,
     -49,   -49,   -49,   -49,   -49,   -49,   -49,   -49,   -49,   -49,
     -49,   -49,   -49,   -49,   -49,   -49,   -49,   -49,   -49,   -49
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      96,    67,     2,    64,    65,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    68,    69,
     100,    55,   112,    59,   124,    57,   137,    94,   139,    26,
      60,    56,    95,    61,    97,    58,   144,    70,   146,   125,
     148,    72,   150,    71,   151,    27,   152,    73,   153,    74,
     154,    76,   155,    78,   156,    75,   157,    77,   158,    79,
     159,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    99,   140,   111,   138,   141,   123,
     167,    64,    65,    64,    65,    26,    64,    65,    80,    82,
     142,   143,   145,   168,    81,    83,   170,   171,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,    84,
     147,    86,   149,    88,   160,    85,   181,    87,   182,    89,
     183,   161,   162,    64,    65,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    62,   163,   164,    63,    64,
      65,   201,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   210,    90,    92,   166,   172,   165,   169,    91,
      93,   173,   175,   177,   179,   174,   176,   186,   180,   184,
     178,   185,   219,   220,   187,   188,   189,   191,   193,   195,
       0,   197,   190,   198,   192,   194,   199,   200,   196,   202,
     203,   205,   207,   209,    98,     0,   204,   206,   211,   216,
     208,   212,   213,   214,   221,   217,   222,     0,   215,   218
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-49)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
      25,    47,     0,    51,    52,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    47,    53,
      55,    40,    57,    40,    59,    40,    61,    45,    63,    37,
      47,    50,    50,    50,    38,    50,    71,    44,    73,    40,
      75,    44,    77,    50,    79,    53,    81,    50,    83,    44,
      85,    44,    87,    44,    89,    50,    91,    50,    93,    50,
      95,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    44,    48,    44,    40,    40,    44,
     125,    51,    52,    51,    52,    37,    51,    52,    44,    44,
      40,    39,    39,   138,    50,    50,   141,   142,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    44,
      39,    44,    39,    44,    48,    50,   161,    50,   163,    50,
     165,    46,    41,    51,    52,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    47,    46,    41,    50,    51,
      52,   186,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,   197,    44,    44,    41,    53,    46,    42,    50,
      50,    39,    39,    39,    39,    53,    53,    40,    42,    41,
      53,    41,   217,   218,    41,    41,    39,    39,    39,    39,
      -1,    40,    53,    41,    53,    53,    41,    41,    53,    53,
      39,    39,    39,    39,    32,    -1,    53,    53,    41,    41,
      53,    53,    53,    53,    43,    49,    43,    -1,    53,    49
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    56,     0,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    37,    53,    57,    58,
      59,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    40,    50,    40,    50,    40,
      47,    50,    47,    50,    51,    52,    60,    47,    47,    53,
      44,    50,    44,    50,    44,    50,    44,    50,    44,    50,
      44,    50,    44,    50,    44,    50,    44,    50,    44,    50,
      44,    50,    44,    50,    45,    50,    60,    38,    59,    44,
      60,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    44,    60,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    44,    60,    40,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    60,    40,    60,
      48,    40,    40,    39,    60,    39,    60,    39,    60,    39,
      60,    60,    60,    60,    60,    60,    60,    60,    60,    60,
      48,    46,    41,    46,    41,    46,    41,    60,    60,    42,
      60,    60,    53,    39,    53,    39,    53,    39,    53,    39,
      42,    60,    60,    60,    41,    41,    40,    41,    41,    39,
      53,    39,    53,    39,    53,    39,    53,    40,    41,    41,
      41,    60,    53,    39,    53,    39,    53,    39,    53,    39,
      60,    41,    53,    53,    53,    53,    41,    49,    49,    60,
      60,    43,    43
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 134 "../bpf_parser.y"
    {}
    break;

  case 3:
/* Line 1792 of yacc.c  */
#line 135 "../bpf_parser.y"
    { }
    break;

  case 4:
/* Line 1792 of yacc.c  */
#line 139 "../bpf_parser.y"
    { }
    break;

  case 5:
/* Line 1792 of yacc.c  */
#line 140 "../bpf_parser.y"
    { }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 144 "../bpf_parser.y"
    { }
    break;

  case 7:
/* Line 1792 of yacc.c  */
#line 148 "../bpf_parser.y"
    { }
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 149 "../bpf_parser.y"
    { }
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 150 "../bpf_parser.y"
    { }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 151 "../bpf_parser.y"
    { }
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 152 "../bpf_parser.y"
    { }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 153 "../bpf_parser.y"
    { }
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 154 "../bpf_parser.y"
    { }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 155 "../bpf_parser.y"
    { }
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 156 "../bpf_parser.y"
    { }
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 157 "../bpf_parser.y"
    { }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 158 "../bpf_parser.y"
    { }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 159 "../bpf_parser.y"
    { }
    break;

  case 19:
/* Line 1792 of yacc.c  */
#line 160 "../bpf_parser.y"
    { }
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 161 "../bpf_parser.y"
    { }
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 162 "../bpf_parser.y"
    { }
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 163 "../bpf_parser.y"
    { }
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 164 "../bpf_parser.y"
    { }
    break;

  case 24:
/* Line 1792 of yacc.c  */
#line 165 "../bpf_parser.y"
    { }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 166 "../bpf_parser.y"
    { }
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 167 "../bpf_parser.y"
    { }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 168 "../bpf_parser.y"
    { }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 169 "../bpf_parser.y"
    { }
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 170 "../bpf_parser.y"
    { }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 174 "../bpf_parser.y"
    { (yyval.number) = (yyvsp[(1) - (1)].number); }
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 175 "../bpf_parser.y"
    { (yyval.number) = (yyvsp[(1) - (1)].number); }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 179 "../bpf_parser.y"
    { }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 183 "../bpf_parser.y"
    { set_curr_label((yyvsp[(1) - (2)].label)); }
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 187 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_IND, 0, 0, (yyvsp[(5) - (6)].number)); }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 189 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0, (yyvsp[(3) - (4)].number)); }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 191 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_PROTOCOL); }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 194 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_PKTTYPE); }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 197 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_IFINDEX); }
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 200 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_NLATTR); }
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 203 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_NLATTR_NEST); }
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 206 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_MARK); }
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 209 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_QUEUE); }
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 212 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_HATYPE); }
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 215 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_RXHASH); }
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 218 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_B | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_CPU); }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 224 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_IND, 0, 0, (yyvsp[(5) - (6)].number)); }
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 226 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0, (yyvsp[(3) - (4)].number)); }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 228 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_PROTOCOL); }
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 231 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_PKTTYPE); }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 234 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_IFINDEX); }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 237 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_NLATTR); }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 240 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_NLATTR_NEST); }
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 243 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_MARK); }
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 246 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_QUEUE); }
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 249 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_HATYPE); }
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 252 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_RXHASH); }
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 255 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_H | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_CPU); }
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 261 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_IMM, 0, 0, (yyvsp[(3) - (3)].number)); }
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 263 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_LEN, 0, 0, 0); }
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 265 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_PROTOCOL); }
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 268 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_PKTTYPE); }
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 271 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_IFINDEX); }
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 274 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_NLATTR); }
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 277 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_NLATTR_NEST); }
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 280 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_MARK); }
    break;

  case 66:
/* Line 1792 of yacc.c  */
#line 283 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_QUEUE); }
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 286 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_HATYPE); }
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 289 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_RXHASH); }
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 292 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0,
			       SKF_AD_OFF + SKF_AD_CPU); }
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 295 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_MEM, 0, 0, (yyvsp[(4) - (5)].number)); }
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 297 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_IND, 0, 0, (yyvsp[(5) - (6)].number)); }
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 299 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LD | BPF_W | BPF_ABS, 0, 0, (yyvsp[(3) - (4)].number)); }
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 304 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LDX | BPF_IMM, 0, 0, (yyvsp[(3) - (3)].number)); }
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 306 "../bpf_parser.y"
    {
		set_curr_instr(BPF_LDX | BPF_MEM, 0, 0, (yyvsp[(4) - (5)].number)); }
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 308 "../bpf_parser.y"
    {
		if ((yyvsp[(2) - (10)].number) != 4 || (yyvsp[(9) - (10)].number) != 0xf) {
			panic("ldxb offset not supported!\n");
		} else {
			set_curr_instr(BPF_LDX | BPF_MSH | BPF_B, 0, 0, (yyvsp[(6) - (10)].number)); } }
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 313 "../bpf_parser.y"
    {
		if ((yyvsp[(2) - (10)].number) != 4 || (yyvsp[(9) - (10)].number) != 0xf) {
			panic("ldxb offset not supported!\n");
		} else {
			set_curr_instr(BPF_LDX | BPF_MSH | BPF_B, 0, 0, (yyvsp[(6) - (10)].number)); } }
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 321 "../bpf_parser.y"
    {
		set_curr_instr(BPF_ST, 0, 0, (yyvsp[(4) - (5)].number)); }
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 326 "../bpf_parser.y"
    {
		set_curr_instr(BPF_STX, 0, 0, (yyvsp[(4) - (5)].number)); }
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 331 "../bpf_parser.y"
    {
		set_jmp_label((yyvsp[(2) - (2)].label), JKL);
		set_curr_instr(BPF_JMP | BPF_JA, 0, 0, 0); }
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 337 "../bpf_parser.y"
    {
		set_jmp_label((yyvsp[(5) - (7)].label), JTL);
		set_jmp_label((yyvsp[(7) - (7)].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JEQ | BPF_K, 0, 0, (yyvsp[(3) - (7)].number)); }
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 341 "../bpf_parser.y"
    {
		set_jmp_label((yyvsp[(4) - (6)].label), JTL);
		set_jmp_label((yyvsp[(6) - (6)].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JEQ | BPF_X, 0, 0, 0); }
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 348 "../bpf_parser.y"
    {
		set_jmp_label((yyvsp[(5) - (7)].label), JTL);
		set_jmp_label((yyvsp[(7) - (7)].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JGT | BPF_K, 0, 0, (yyvsp[(3) - (7)].number)); }
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 352 "../bpf_parser.y"
    {
		set_jmp_label((yyvsp[(4) - (6)].label), JTL);
		set_jmp_label((yyvsp[(6) - (6)].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JGT | BPF_X, 0, 0, 0); }
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 359 "../bpf_parser.y"
    {
		set_jmp_label((yyvsp[(5) - (7)].label), JTL);
		set_jmp_label((yyvsp[(7) - (7)].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JGE | BPF_K, 0, 0, (yyvsp[(3) - (7)].number)); }
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 363 "../bpf_parser.y"
    {
		set_jmp_label((yyvsp[(4) - (6)].label), JTL);
		set_jmp_label((yyvsp[(6) - (6)].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JGE | BPF_X, 0, 0, 0); }
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 370 "../bpf_parser.y"
    {
		set_jmp_label((yyvsp[(5) - (7)].label), JTL);
		set_jmp_label((yyvsp[(7) - (7)].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JSET | BPF_K, 0, 0, (yyvsp[(3) - (7)].number)); }
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 374 "../bpf_parser.y"
    {
		set_jmp_label((yyvsp[(4) - (6)].label), JTL);
		set_jmp_label((yyvsp[(6) - (6)].label), JFL);
		set_curr_instr(BPF_JMP | BPF_JSET | BPF_X, 0, 0, 0); }
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 381 "../bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_ADD | BPF_K, 0, 0, (yyvsp[(3) - (3)].number)); }
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 383 "../bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_ADD | BPF_X, 0, 0, 0); }
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 388 "../bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_SUB | BPF_K, 0, 0, (yyvsp[(3) - (3)].number)); }
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 390 "../bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_SUB | BPF_X, 0, 0, 0); }
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 395 "../bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_MUL | BPF_K, 0, 0, (yyvsp[(3) - (3)].number)); }
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 397 "../bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_MUL | BPF_X, 0, 0, 0); }
    break;

  case 94:
/* Line 1792 of yacc.c  */
#line 402 "../bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_DIV | BPF_K, 0, 0, (yyvsp[(3) - (3)].number)); }
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 404 "../bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_DIV | BPF_X, 0, 0, 0); }
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 409 "../bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_AND | BPF_K, 0, 0, (yyvsp[(3) - (3)].number)); }
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 411 "../bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_AND | BPF_X, 0, 0, 0); }
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 416 "../bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_OR | BPF_K, 0, 0, (yyvsp[(3) - (3)].number)); }
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 418 "../bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_OR | BPF_X, 0, 0, 0); }
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 423 "../bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_LSH | BPF_K, 0, 0, (yyvsp[(3) - (3)].number)); }
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 425 "../bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_LSH | BPF_X, 0, 0, 0); }
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 430 "../bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_RSH | BPF_K, 0, 0, (yyvsp[(3) - (3)].number)); }
    break;

  case 103:
/* Line 1792 of yacc.c  */
#line 432 "../bpf_parser.y"
    {
		set_curr_instr(BPF_ALU | BPF_RSH | BPF_X, 0, 0, 0); }
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 437 "../bpf_parser.y"
    {
		set_curr_instr(BPF_RET | BPF_A, 0, 0, 0); }
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 439 "../bpf_parser.y"
    {
		set_curr_instr(BPF_RET | BPF_K, 0, 0, (yyvsp[(3) - (3)].number)); }
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 444 "../bpf_parser.y"
    {
		set_curr_instr(BPF_MISC | BPF_TAX, 0, 0, 0); }
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 449 "../bpf_parser.y"
    {
		set_curr_instr(BPF_MISC | BPF_TXA, 0, 0, 0); }
    break;


/* Line 1792 of yacc.c  */
#line 2444 "/builddir/build/BUILD/netsniff-ng-0.5.7/src/build/bpfc/bpf_parser.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 453 "../bpf_parser.y"


static void stage_1_inline(void)
{
	yyparse();
}

static void stage_2_label_reduce(void)
{
	int i, max = curr_instr, off;

	/* 1. reduce k jumps */
	for (i = 0; i < max; ++i) {
		if (labels_k[i] != NULL) {
			off = find_intr_offset_or_panic(labels_k[i]);
			out[i].k = (uint32_t) (off - i - 1);
		}
	}

	/* 1. reduce jt jumps */
	for (i = 0; i < max; ++i) {
		if (labels_jt[i] != NULL) {
			off = find_intr_offset_or_panic(labels_jt[i]);
			out[i].jt = (uint8_t) (off - i -1);
		}
	}

	/* 1. reduce jf jumps */
	for (i = 0; i < max; ++i) {
		if (labels_jf[i] != NULL) {
			off = find_intr_offset_or_panic(labels_jf[i]);
			out[i].jf = (uint8_t) (off - i - 1);
		}
	}
}

int compile_filter(char *file, int verbose)
{
	int i;
	struct sock_fprog res;

	yyin = fopen(file, "r");
	if (!yyin)
		panic("Cannot open file!\n");

	memset(out, 0, sizeof(out));
	memset(labels, 0, sizeof(labels));
	memset(labels_jf, 0, sizeof(labels_jf));
	memset(labels_jt, 0, sizeof(labels_jt));
	memset(labels_k, 0, sizeof(labels_k));

	stage_1_inline();
	stage_2_label_reduce();

	res.filter = out;
	res.len = curr_instr;

	if (verbose) {
		printf("Generated program:\n");
		bpf_dump_all(&res);
	}
	if (verbose) {
		printf("Validating: ");
		fflush(stdout);
	}
	if (bpf_validate(&res) == 0) {
		if (verbose)
			whine("semantic error! BPF validation failed!\n");
		else
			panic("Semantic error! BPF validation failed! "
			      "Try -V for debugging output!\n");
	} else if (verbose)
		printf("is runnable!\n");
	if (verbose)
		printf("Result:\n");
	for (i = 0; i < res.len; ++i) {
		printf("{ 0x%x, %u, %u, 0x%08x },\n",
		       res.filter[i].code, res.filter[i].jt,
		       res.filter[i].jf, res.filter[i].k);
		if (labels[i] != NULL)
			xfree(labels[i]);
		if (labels_jt[i] != NULL)
			xfree(labels_jt[i]);
		if (labels_jf[i] != NULL)
			xfree(labels_jf[i]);
		if (labels_k[i] != NULL)
			xfree(labels_k[i]);
	}

	fclose(yyin);
	return 0;
}

void yyerror(const char *err)
{
	panic("Syntax error at line %d: %s! %s!\n",
	      yylineno, yytext, err);
}
